﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Data.SqlClient;


namespace uDataSet1
{
    public partial class Form1 : Form
    {
        //define os objetos SqlConnection, DataSet
        //SqlDataAdapter e o nome da tabela
        private SqlConnection conn;
        private SqlDataAdapter daProdutos;
        private DataSet dsProdutos;
        private const string tabela = "Produtos";
        private String codigo = "";

        public Form1()
        {
            InitializeComponent();
        }

        private void btnPreencheGrid_Click(object sender, EventArgs e)
        {
            IniciaDados();
            //exibe o dataset no controle datagridview - dgvProdutos
            dgvProdutos.DataSource = dsProdutos;
            dgvProdutos.DataMember = tabela;
            btnIncluir.Enabled = true;
            btnExcluir.Enabled = true;
            btnAlterar.Enabled = true;
        }
        // definição dos objetos dataset, sqldataadapter e sqlcommandbuilder
        public void IniciaDados()
        {
            try
            {
                // instancia uma nova conexão usando a string de conexão
                // com o banco de dados Northwind do SQL Server 2005 Express
                conn = new SqlConnection("Server=MAC\\SQLEXPRESS;DataBase=Northwind;Integrated Security=SSPI");

                // 1. instancia um novo DataSet
                dsProdutos = new DataSet();

                // 2. inicia o SqlDataAdapte passando o comando SQL para selecionar codigo e nome
                // do produto e a conexão com o banco de dados
                daProdutos = new SqlDataAdapter("Select ProductID, ProductName from Products order by ProductID", conn);

                // 3. prepara o dataset para os comandos insert, update, e delete
                //SqlCommandBuilder cmdBuilder = new SqlCommandBuilder(daProdutos);
                //daProdutos.InsertCommand = cmdBuilder.GetInsertCommand();
                //daProdutos.UpdateCommand = cmdBuilder.GetUpdateCommand();
                //daProdutos.DeleteCommand = cmdBuilder.GetDeleteCommand();

                // 4. preenche o dataset
                daProdutos.Fill(dsProdutos, tabela);
                //
            }
            catch(Exception ex)
            {
                //se houver erro exibe a mensagem
                MessageBox.Show(ex.Message);
            }
        }

        private void btnIncluir_Click(object sender, EventArgs e)
        {
            daProdutos = new SqlDataAdapter("SELECT ProductID, ProductName FROM Products", conn);
            SqlCommandBuilder cmdbldr = new SqlCommandBuilder(daProdutos);
            dsProdutos = new DataSet();

            daProdutos.Fill(dsProdutos);

            DataRow registro = dsProdutos.Tables[0].NewRow();

            registro["ProductName"] = "Macoratti_";
            dsProdutos.Tables[0].Rows.Add(registro);
            daProdutos.Update(dsProdutos);
            MessageBox.Show("Registro incluido.");
        }

        private void btnExcluir_Click(object sender, EventArgs e)
        {
            daProdutos = new SqlDataAdapter("SELECT ProductID, ProductName FROM Products order by ProductID", conn);
            SqlCommandBuilder cmdbldr = new SqlCommandBuilder(daProdutos);

            dsProdutos = new DataSet();
            daProdutos.Fill(dsProdutos);

            DataColumn[] chave = new DataColumn[1];

            chave[0] = dsProdutos.Tables[0].Columns[0];
            dsProdutos.Tables[0].PrimaryKey = chave;

            codigo = dgvProdutos.CurrentRow.Cells["ProductID"].Value.ToString();

            if (codigo != null || !codigo.Equals(""))
            {
               DataRow registro = dsProdutos.Tables[0].Rows.Find(codigo);
               registro.Delete();
               daProdutos.Update(dsProdutos);
               MessageBox.Show("Registro excluido.");
            }
            else
            {
                MessageBox.Show("Registro não localizado.");
            }
        }

        private void btnAlterar_Click(object sender, EventArgs e)
        {
            
            daProdutos = new SqlDataAdapter("SELECT ProductID, ProductName FROM Products order by ProductID", conn);
            SqlCommandBuilder cmdbldr = new SqlCommandBuilder(daProdutos);

            dsProdutos = new DataSet();
            daProdutos.Fill(dsProdutos);

            DataColumn[] chave = new DataColumn[1];

            chave[0] = dsProdutos.Tables[0].Columns[0];
            dsProdutos.Tables[0].PrimaryKey = chave;

            codigo = dgvProdutos.CurrentRow.Cells["ProductID"].Value.ToString();

            if (codigo != null || !codigo.Equals(""))
            {
                DataRow registro = dsProdutos.Tables[0].Rows.Find(codigo);
                registro["ProductName"] = registro["ProductName"] + " # ";
                daProdutos.Update(dsProdutos);
                MessageBox.Show("Registro alterado.");
            }
            else
            {
                MessageBox.Show("Registro não localizado.");
            }
       
        }
    }
}
